-- MySQL dump 10.13  Distrib 5.1.67, for pc-linux-gnu (x86_64)
--
-- Host: localhost    Database: turkserver
-- ------------------------------------------------------
-- Server version	5.1.67-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `experiment`
--

DROP TABLE IF EXISTS `experiment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `experiment` (
  `id` varchar(24) NOT NULL DEFAULT '',
  `setId` varchar(24) DEFAULT NULL,
  `participants` int(11) DEFAULT NULL,
  `inputdata` varchar(24) DEFAULT NULL,
  `startTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `endTime` timestamp NULL DEFAULT NULL,
  `results` mediumtext,
  PRIMARY KEY (`id`),
  KEY `experiment_ibfk_1` (`setId`),
  CONSTRAINT `experiment_ibfk_1` FOREIGN KEY (`setId`) REFERENCES `sets` (`name`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `experiment`
--

LOCK TABLES `experiment` WRITE;
/*!40000 ALTER TABLE `experiment` DISABLE KEYS */;
/*!40000 ALTER TABLE `experiment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qual`
--

DROP TABLE IF EXISTS `qual`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `qual` (
  `workerId` varchar(40) NOT NULL,
  `qual` varchar(30) NOT NULL,
  `value` int(11) NOT NULL,
  PRIMARY KEY (`workerId`,`qual`),
  KEY `workerId` (`workerId`,`qual`),
  KEY `fk_qual_1_idx` (`workerId`),
  CONSTRAINT `fk_qual_1` FOREIGN KEY (`workerId`) REFERENCES `worker` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qual`
--

LOCK TABLES `qual` WRITE;
/*!40000 ALTER TABLE `qual` DISABLE KEYS */;
/*!40000 ALTER TABLE `qual` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quiz`
--

DROP TABLE IF EXISTS `quiz`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `quiz` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sessionId` varchar(40) DEFAULT NULL,
  `workerId` varchar(14) DEFAULT NULL,
  `setId` varchar(24) DEFAULT NULL,
  `timeReceived` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `numCorrect` int(11) DEFAULT '0',
  `numTotal` int(11) DEFAULT '0',
  `score` double DEFAULT NULL,
  `answers` text,
  PRIMARY KEY (`id`),
  KEY `workerId` (`workerId`),
  KEY `quiz_ibfk_1` (`sessionId`),
  CONSTRAINT `quiz_ibfk_2` FOREIGN KEY (`workerId`) REFERENCES `worker` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quiz`
--

LOCK TABLES `quiz` WRITE;
/*!40000 ALTER TABLE `quiz` DISABLE KEYS */;
/*!40000 ALTER TABLE `quiz` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `round`
--

DROP TABLE IF EXISTS `round`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `round` (
  `experimentId` varchar(24) NOT NULL,
  `roundnum` int(11) NOT NULL,
  `startTime` timestamp NULL DEFAULT NULL,
  `endTime` timestamp NULL DEFAULT NULL,
  `inputdata` varchar(24) DEFAULT NULL,
  `results` mediumtext,
  PRIMARY KEY (`experimentId`,`roundnum`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `round`
--

LOCK TABLES `round` WRITE;
/*!40000 ALTER TABLE `round` DISABLE KEYS */;
/*!40000 ALTER TABLE `round` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `session` (
  `hitId` varchar(30) NOT NULL,
  `setId` varchar(24) DEFAULT NULL,
  `assignmentId` varchar(30) DEFAULT NULL,
  `workerId` varchar(14) DEFAULT NULL,
  `username` varchar(40) DEFAULT NULL,
  `lobbyTime` timestamp NULL DEFAULT NULL,
  `ipAddr` varchar(16) DEFAULT NULL,
  `experimentId` varchar(24) DEFAULT NULL,
  `numDisconnects` int(11) DEFAULT NULL,
  `inactivePercent` double DEFAULT NULL,
  `inactiveData` text,
  `payment` decimal(10,2) DEFAULT NULL,
  `bonus` decimal(10,2) DEFAULT NULL,
  `paid` bit(1) DEFAULT b'0',
  `bonusPaid` bit(1) DEFAULT b'0',
  `hitStatus` varchar(16) DEFAULT NULL,
  `comment` text,
  PRIMARY KEY (`hitId`),
  UNIQUE KEY `assignmentId` (`assignmentId`),
  KEY `workerId` (`workerId`),
  KEY `experimentId` (`experimentId`),
  KEY `setId` (`setId`),
  KEY `fk_session_1_idx` (`experimentId`),
  KEY `fk_session_2_idx` (`setId`),
  KEY `fk_session_3_idx` (`workerId`),
  CONSTRAINT `fk_session_1` FOREIGN KEY (`experimentId`) REFERENCES `experiment` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_session_2` FOREIGN KEY (`setId`) REFERENCES `sets` (`name`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_session_3` FOREIGN KEY (`workerId`) REFERENCES `worker` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `session`
--

LOCK TABLES `session` WRITE;
/*!40000 ALTER TABLE `session` DISABLE KEYS */;
/*!40000 ALTER TABLE `session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sets`
--

DROP TABLE IF EXISTS `sets`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sets` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(24) NOT NULL,
  `descript` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sets`
--

LOCK TABLES `sets` WRITE;
/*!40000 ALTER TABLE `sets` DISABLE KEYS */;
/*!40000 ALTER TABLE `sets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worker`
--

DROP TABLE IF EXISTS `worker`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worker` (
  `id` varchar(14) NOT NULL,
  `notify` enum('off','on') DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worker`
--

LOCK TABLES `worker` WRITE;
/*!40000 ALTER TABLE `worker` DISABLE KEYS */;
/*!40000 ALTER TABLE `worker` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-04-10 12:00:36
