# Old schema before revamped database

CREATE TABLE IF NOT EXISTS worker (id VARCHAR(14) NOT NULL PRIMARY KEY,notify ENUM('off', 'on')) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS sets (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,name VARCHAR(24) NOT NULL UNIQUE KEY,descript TEXT) ENGINE = InnoDB;

INSERT IGNORE INTO sets (name) VALUES ("EXPIRED");

CREATE TABLE IF NOT EXISTS experiment (id VARCHAR(24) NOT NULL PRIMARY KEY,setId VARCHAR(24),players INT,file VARCHAR(24),startTime TIMESTAMP DEFAULT CURRENT_TIMESTAMP,endTime TIMESTAMP DEFAULT 0,FOREIGN KEY(setId) REFERENCES sets(name) ON UPDATE CASCADE) ENGINE = InnoDB;

INSERT IGNORE INTO experiment (id, startTime) VALUES ("EXPIRED", 0);

CREATE TABLE IF NOT EXISTS session (hitId VARCHAR(30) NOT NULL PRIMARY KEY,setId VARCHAR(24),assignmentId VARCHAR(30) UNIQUE,workerId VARCHAR(14),username VARCHAR(40),lobbyTime TIMESTAMP DEFAULT 0,ipAddr VARCHAR(16),experimentId VARCHAR(24),inactivePercent DOUBLE,paid DECIMAL(10,2),bonusPaid DECIMAL(10,2),hitStatus VARCHAR(16),comment TEXT,FOREIGN KEY(setId) REFERENCES sets(name) ON UPDATE CASCADE,FOREIGN KEY(workerId) REFERENCES worker(id),FOREIGN KEY(experimentId) REFERENCES experiment(id)) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS quiz (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,sessionId VARCHAR(40),workerId VARCHAR(14),setId VARCHAR(24),numCorrect INT DEFAULT 0,numTotal INT DEFAULT 0,FOREIGN KEY(sessionId) REFERENCES session(id) ON DELETE CASCADE,FOREIGN KEY(workerId) REFERENCES worker(id)) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS qual (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,workerId VARCHAR(40),qual VARCHAR(30),value INT NOT NULL,FOREIGN KEY(workerId) REFERENCES worker(id), UNIQUE (workerId, qual) ) ENGINE = InnoDB;
